import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import ij.plugin.*;
import ij.plugin.frame.*;

/* step through a N dimentional dataset one dimension at a time.
 */
public class Frame_Slider implements PlugIn, DialogListener, ItemListener, MouseListener {

   TreeMap<String,TreeMap<Double,Double>> vars = null;
   TreeMap<String,Label> valLabels = new TreeMap<String,Label>();
   Label zLabel = null;
   ImagePlus imp = null;
   Panel panel = new Panel();

   public void run(String arg) {
      run(IJ.getImage());
      }
   public static void jog(Point loc, ImagePlus ... imps) {
      (new Thread(new Runnable() { public void run() {(new Frame_Slider()).run(loc, imps);} }) ).start();
      }
   public static void jog(ImagePlus ... imps) {
      (new Thread(new Runnable() { public void run() {(new Frame_Slider()).run(imps);} }) ).start();
      }
   public void run(ImagePlus ... imps) {
      run(null, imps);
      }
   public void run(Point loc, ImagePlus ... imps) {

      imp = imps[0]; // IJ.getImage();

      GenericDialog gd = new NonBlockingGenericDialog("Frame_Slider");
      if (loc != null)
         gd.setLocation(loc.x,loc.y);
      Font font = (new Dialog(IJ.getInstance())).getFont();

      gd.addPanel(panel,GridBagConstraints.NORTH, new Insets(0, 0, 0, 0));
      panel.setLayout(new GridBagLayout());
      for(ImagePlus i : imps)
         addChoiceImage(i);
      itemStateChanged(null);

      gd.addSlider("z",1,imp.getNSlices(),imp.getZ());
      Scrollbar zs = (Scrollbar)gd.getSliders().lastElement();
      zs.setPreferredSize(new Dimension(200,30));
      gd.getLabel().addMouseListener(this);
      stMap.put((Scrollbar)gd.getSliders().lastElement(),
                (TextField)gd.getNumericFields().lastElement());
      gd.addToSameRow();
      gd.addMessage(""+getZ(imp,imp.getZ()),new Font("Monospaced",Font.BOLD,font.getSize()));
      zLabel = (Label)gd.getMessage();
      zLabel.setAlignment(Label.RIGHT);
      ((Scrollbar)gd.getSliders().lastElement()).addMouseWheelListener(new MouseWheelListener() {
            public void mouseWheelMoved(MouseWheelEvent e) {
               Scrollbar sb = (Scrollbar)e.getSource();
               int i = sb.getValue(); /* + e.getWheelRotation();
               sb.setValue(i);
               i = sb.getValue();
               stMap.get(sb).setText(""+i); */
               zLabel.setText(""+getZ(imp,i));
               }
            });

      TreeMap<String,Double> cvv = F_Project.getVars(imp,imp.getT());
      if (cvv == null) {
         cvv = new TreeMap<String,Double>();
         cvv.put("f",(Double)(double)imp.getT());
         }

      vars = F_Project.getVars(imp);
//IJ.log("vars.size = "+vars.size());
      if (vars.isEmpty()) {
         TreeMap<Double,Double> tmp = new TreeMap<Double,Double>();
         int nf = imp.getNFrames();
         for(int f=1; f<=nf; f++)
            tmp.put(new Double(f),new Double(f));
         vars.put("f",tmp);
         }
      for(Map.Entry<String,TreeMap<Double,Double>> e : vars.entrySet()) {
//IJ.log("vars "+e.getKey());
         gd.addSlider(e.getKey(),0, e.getValue().size()-1,e.getValue().get(cvv.get(e.getKey())).intValue()-1);
         gd.getLabel().addMouseListener(this);
         vlMap.put(e.getKey(),gd.getLabel());
         Scrollbar sb = (Scrollbar)gd.getSliders().lastElement();
         sb.setPreferredSize(new Dimension(200,30));
         tiedMap.put(sb,new Vector<Scrollbar>());
         lsMap.put(gd.getLabel(),sb);
         tlMap.put((TextField)gd.getNumericFields().lastElement(),gd.getLabel());
         stMap.put(sb,(TextField)gd.getNumericFields().lastElement());
         //sb.setPreferredSize(new Dimension(sb.getWidth(),stMap.get(sb).getHeight()));
         //sb.setSize(sb.getWidth(),stMap.get(sb).getHeight());
         sb.addAdjustmentListener(new AdjustmentListener() {
            public void adjustmentValueChanged(AdjustmentEvent e) {
               Scrollbar sb = (Scrollbar)e.getSource();
//IJ.log("SB "+sb);
               int i = sb.getValue();
               for(Scrollbar s : tiedMap.get(sb)) {
                  s.setValue(i);
                  stMap.get(s).setText(""+i);
                  //valLabels.get(tlMap.get(stMap.get(s)).getText()).setText(""+val);
                  }
               }
            });
         sb.addMouseWheelListener(new MouseWheelListener() {
            public void mouseWheelMoved(MouseWheelEvent e) {
               Scrollbar sb = (Scrollbar)e.getSource();
//IJ.log("MW "+sb);
               int i = sb.getValue(); /* + e.getWheelRotation();
               sb.setValue(i);
               i = sb.getValue();
               stMap.get(sb).setText(""+i); */
               for(Scrollbar s : tiedMap.get(sb)) {
                  s.setValue(i);
                  stMap.get(s).setText(""+i);
                  }               
               }
            });
         gd.addToSameRow();
         gd.addMessage(""+cvv.get(e.getKey()),new Font("Monospaced",Font.BOLD,font.getSize()));
         Label l = (Label)gd.getMessage();
         l.setAlignment(Label.RIGHT);
         valLabels.put(e.getKey(),l);
         }
      
      gd.addDialogListener(this);
      (gd.getButtons()[0]).setEnabled(false);
      (gd.getButtons()[1]).addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { closem = 0 != (e.getModifiers()&ActionEvent.SHIFT_MASK);} });
      gd.showDialog();
      if (closem) 
         for(Map.Entry<Choice,ImagePlus> e : ic.entrySet())
            if (e.getValue() != null)
               e.getValue().close();
      }

   boolean closem = false;

   Map<Choice,ImagePlus> ic = new HashMap<Choice,ImagePlus>();
   Map<Choice,Label>     il = new HashMap<Choice,Label>();
   public void itemStateChanged(ItemEvent e) {

      GridBagConstraints gbc = new GridBagConstraints();
      gbc.fill = GridBagConstraints.VERTICAL;
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.weightx = 0.5;

      Choice c = (e == null) ? null : (Choice)e.getSource();

      if (c == null || ic.get(c) == null) {
         Choice cc = impChoice(null);
         gbc.gridx = 0;
         gbc.gridy = ic.size();
         panel.add(cc,gbc);
         ic.put(cc,null);

         Label l = new Label("        ",Label.RIGHT);
         gbc.gridx = 1;
         panel.add(l,gbc);
         il.put(cc,l);
         }

      //panel.revalidate();
      //panel.repaint();
      if (e != null) ((GenericDialog)panel.getParent()).pack();

      if (c == null) return;

      ic.put(c,(c.getSelectedIndex() > 0) ? WindowManager.getImage(imgIds[c.getSelectedIndex()-1]) : null);
      }

   private void addChoiceImage(ImagePlus imp) {
      GridBagConstraints gbc = new GridBagConstraints();
      gbc.fill = GridBagConstraints.VERTICAL;
      Choice c = impChoice(imp);
         
      gbc.gridy = ic.size();
      panel.add(c,gbc);
      ic.put(c,imp);

      Label l = new Label("        ",Label.RIGHT);
      gbc.gridx = 1;
      panel.add(l,gbc);
      il.put(c,l);
      }

   int[] imgIds = WindowManager.getIDList();
   private Choice impChoice(ImagePlus imp) {
      Choice c = new Choice();
      c.add("<none>");
      c.select(0);
      for(int i=0; i<imgIds.length; i++) {
         ImagePlus tmpimp = WindowManager.getImage(imgIds[i]);
         c.add(tmpimp.getTitle());
         if (tmpimp == imp)
            c.select(i+1);
         }
      c.addItemListener(this);
      return c;
      }

   public static double getZ(ImagePlus imp, int s) {
//IJ.log("sl"+s+"="+imp.getStack().getSliceLabel(imp.getStackIndex(1,s,1)));
      String[] sls = null;
      try { sls = imp.getStack().getSliceLabel(imp.getStackIndex(1,s,1)).split("\n",2); } 
      catch(Throwable t) { return s; }
      if (sls.length < 2) return s;
      for(String sll : sls[1].split("\n")) {
         String[] vv = sll.split(" = |=| ");
         if (vv[0].toLowerCase().equals("zc"))
            if (vv.length == 2) return Double.parseDouble(vv[1]);
                           else return s;
         }
      return s;
      }
   public static void setZ(ImagePlus imp, double z) {
      int nz = imp.getNSlices();
      int minAt = 1;
      double min = Math.abs(z-getZ(imp,minAt));
      for(int s=1; s<nz; s++) {
         double v = Math.abs(z-getZ(imp,s+1));
         if (v < min) {
            min = v;
            minAt = s+1;
//IJ.log("minAt="+minAt);
            }
         }
      imp.setZ(minAt);
      }

   public boolean dialogItemChanged(GenericDialog gd, AWTEvent ev) {
      int z = (int)gd.getNextNumber();
      zLabel.setText(""+getZ(imp,z));
      for(ImagePlus imp : ic.values())
         if (imp != null) 
            imp.setZ(z);

      if (tlMap.get((TextField)ev.getSource()) == null) return false;

      String var = tlMap.get((TextField)ev.getSource()).getText();
      int n = 1;
//IJ.log("DIC "+var);

      TreeMap<String,Double> varval = new TreeMap<String,Double>();
      for(Map.Entry<String,TreeMap<Double,Double>> e : vars.entrySet()) {
/*
         if (var.equals(e.getKey())) {
            n = (int)gd.getNextNumber();
            continue;
            }
*/
         Double val = e.getValue().keySet().toArray(new Double[0])[(int)gd.getNextNumber()];
         //int n = e.getValue().get(val).intValue();
         varval.put(e.getKey(),val);
//IJ.log(e.getKey()+" = "+val);
         valLabels.get(e.getKey()).setText(""+val); //+(n==1?"":"x"+n));
         }
      {
         int f = F_Project.findFrame(imp,varval);//,n+1);
         TreeMap<String,Double> cvv = F_Project.getVars(imp,f);
         double val = cvv.get(var);
//IJ.log("val "+n+"/"+f+" = "+val);
         valLabels.get(var).setText(""+val);
      }

      for(ImagePlus imp : ic.values()) {
         if (imp == null) continue;
         imp.setZ(z);
         int f = F_Project.findFrame(imp,varval);//,n+1);
//for(Map.Entry<String,Double> e : varval.entrySet())
//   IJ.log(e.getKey()+" => "+e.getValue());
         if (f>0) imp.setT(f);
             else try { imp.setT(varval.get("f").intValue()); } catch(Throwable t) { /* IJ.log(""+imp+" has no f"); */ }
         imp.updateImage();
         }

      gd.pack();
      gd.repaint();
      return false;
      }

   Label cl = null;
   String varvar = null;
   Map<Scrollbar,Vector<Scrollbar>> tiedMap = new HashMap<Scrollbar,Vector<Scrollbar>>();
   Map<String,Label>                vlMap   = new HashMap<String,Label>();
   Map<Label,Scrollbar>             lsMap   = new HashMap<Label,Scrollbar>();
   Map<TextField,Label>             tlMap   = new HashMap<TextField,Label>();
   Map<Scrollbar,TextField>         stMap   = new HashMap<Scrollbar,TextField>();
   public void mouseClicked(MouseEvent me) { try {
      double[] x = null;
      String var = ((Label)me.getSource()).getText();
      if (me.getButton() == MouseEvent.BUTTON3) {
         if (varvar != null) vlMap.get(varvar).setForeground(Color.BLACK);
         if (var.equals(varvar)) { varvar = null; return; }
         varvar = var;
         vlMap.get(varvar).setForeground(Color.GREEN);
         return;
         }
      TreeMap<String,Double> varval = new TreeMap<String,Double>();
      String varvalstr = "";
      for(Map.Entry<String,TreeMap<Double,Double>> e : vars.entrySet()) {
         if (var.equals(e.getKey())) {
            Double[] vals = e.getValue().keySet().toArray(new Double[0]);
            x = new double[vals.length];
            for(int i=0; i<x.length; i++)
               x[i] = vals[i];
            }
         else if (tiedMap.get(lsMap.get(vlMap.get(e.getKey()))).contains(lsMap.get((Label)me.getSource()))) {}
         else {
            Double val = new Double(valLabels.get(e.getKey()).getText().split("x",2)[0]);
            varval.put(e.getKey(),val);
            varvalstr += ","+e.getKey()+"="+val;
            //valLabels.get(e.getKey()).setText(""+val);
            }
         }
      if (varvalstr.length() > 0)
         varvalstr = " at "+varvalstr.substring(1);
      for(ImagePlus imp : ic.values().toArray(new ImagePlus[0]))
         if (imp != null) 
            if (me.getButton() == MouseEvent.BUTTON1  && imp.getRoi() != null) {
               boolean[] useFrames = F_Project.findFrames(imp,varval);
               TreeMap<String,Vector<Double>> vMap = F_Project.vars(imp,useFrames);
               x = vD2d(vMap.get(var));
               (new F_Profiler()).run(imp, x, useFrames, var+varvalstr, "Y");
               }
            else if (me.getButton() == MouseEvent.BUTTON2) {
               if (me.isControlDown())
                  varval.clear();
               if (me.isShiftDown())
                  varval.put(var, new Double(valLabels.get(var).getText().split("x",2)[0]));
               if (me.isAltDown()) {
                  ImagePlus[] newimps = F_Project.meanDev(imp,"all", "repeats "+var);
                  if (newimps != null)
                     for(ImagePlus tmp : newimps)
                        if (tmp != null)
                           tmp.show();
                  }
               else {
                  /*
                  String str = "Extracting...";
                  for(Map.Entry<String,Double> e : varval.entrySet())
                     str += "\n"+e.getKey() +" = "+e.getValue();
                  IJ.log(str);
                  */
                  if (varval.isEmpty()) {
                     for(ImagePlus newimp : F_Project.extract(imp,"all","repeats "+var))
                        if (newimp != null)
                           newimp.show();
                     }
                  else {
                     ImagePlus newimp = F_Project.extractFrames(imp,varval);
                     if (newimp != null)
                        newimp.show();
                     }
                  }
               }
         }
      catch(Exception e) {
         StringWriter sw = new StringWriter();
         e.printStackTrace(new PrintWriter(sw));
         IJ.log("Error "+sw.toString());
         }
      }
   public void mouseEntered(MouseEvent me) { 
      Label l = (Label)me.getSource();
      cl = (Label)me.getSource();
      l.setFont(l.getFont().deriveFont(Font.ITALIC));
      }
   public void mouseExited(MouseEvent me) { 
      cl = null;
      Label l = (Label)me.getSource();
      l.setFont(l.getFont().deriveFont(Font.PLAIN));
      }
   public void mousePressed(MouseEvent me) { 
      Label l = (Label)me.getSource();
      //IJ.log("From: "+lsMap.get(l));
      }
   public void mouseReleased(MouseEvent me) { 
      Label l = (Label)me.getSource();
      if (l == cl) return;
      IJ.log(""+l+" <=> "+cl);
      if (cl != null) {
         tiedMap.get(lsMap.get( l)).add(lsMap.get(cl));
         tiedMap.get(lsMap.get(cl)).add(lsMap.get( l));
         }
      }

   private static double[] vD2d(Vector<Double> vD) {
      if (vD == null) return null;
      double[] arrd = new double[vD.size()];
      for(int i=0; i<vD.size(); i++)
         arrd[i] = vD.get(i);
      return arrd;
      }
}
